;============================================================
;
; DexBasic is based on a idea by Jeff Duntemann for a HL
; macro language, mixed with the Dex Operating System.
; That will help to teach low level programming in both
; basic and asm.
; Plus make it easier to program embedded systems.
;
; Code input by:
;   Dex (Craig Bamford)
;   krom (Peter Lemon)
;   rCX
;   Stephen
;
; This include is for the Raspberry Pi.
;
; Also available for
;   windows
;   linux (x86)
;   Dos
;   DexOS
;
; Thanks to:
;   Tomasz Grysztar (for Fasm)
;   revolution (for fasmarm)
;   and everyone on the raspberry pi forum
;============================================================
LOW			       = 0			 ; Set Gpio to low
HIGH			       = 1			 ; Set Gpio to high
INPUT			       = 0			 ; Set Gpio to input
OUTPUT			       = 1			 ; Set Gpio to output
ALT0			       = 4			 ; Set Gpio to alternate function 0
ALT1			       = 5			 ; Set Gpio to alternate function 1
ALT2			       = 6			 ; Set Gpio to alternate function 2
ALT3			       = 7			 ; Set Gpio to alternate function 3
ALT4			       = 3			 ; Set Gpio to alternate function 4
ALT5			       = 2			 ; Set Gpio to alternate function 5
;========================================================;
; **** GPIO numbers as used in BCM2835 PDF page 102 **** ;
;========================================================;
GPIO0			       = 0			 ; Gpio number
GPIO1			       = 1			 ; Gpio number
GPIO2			       = 2			 ; Gpio number
GPIO3			       = 3			 ; Gpio number
GPIO4			       = 4			 ; Gpio number
GPIO5			       = 5			 ; Gpio number
GPIO6			       = 6			 ; Gpio number
GPIO7			       = 7			 ; Gpio number
GPIO8			       = 8			 ; Gpio number
GPIO9			       = 9			 ; Gpio number
GPIO10			       = 10			 ; Gpio number
GPIO11			       = 11			 ; Gpio number
GPIO12			       = 12			 ; Gpio number
GPIO13			       = 13			 ; Gpio number
GPIO14			       = 14			 ; Gpio number
GPIO15			       = 15			 ; Gpio number
GPIO16			       = 16			 ; Gpio number
GPIO17			       = 17			 ; Gpio number
GPIO18			       = 18			 ; Gpio number
GPIO19			       = 19			 ; Gpio number
GPIO20			       = 20			 ; Gpio number
GPIO21			       = 21			 ; Gpio number
GPIO22			       = 22			 ; Gpio number
GPIO23			       = 23			 ; Gpio number
GPIO24			       = 24			 ; Gpio number
GPIO25			       = 25			 ; Gpio number
GPIO26			       = 26			 ; Gpio number
GPIO27			       = 27			 ; Gpio number
GPIO28			       = 28			 ; Gpio number
GPIO29			       = 29			 ; Gpio number
GPIO30			       = 30			 ; Gpio number
GPIO31			       = 31			 ; Gpio number
GPIO32			       = 32			 ; Gpio number
GPIO33			       = 33			 ; Gpio number
GPIO34			       = 34			 ; Gpio number
GPIO35			       = 35			 ; Gpio number
GPIO36			       = 36			 ; Gpio number
GPIO37			       = 37			 ; Gpio number
GPIO38			       = 38			 ; Gpio number
GPIO39			       = 39			 ; Gpio number
GPIO40			       = 40			 ; Gpio number
GPIO41			       = 41			 ; Gpio number
GPIO42			       = 42			 ; Gpio number
GPIO43			       = 43			 ; Gpio number
GPIO44			       = 44			 ; Gpio number
GPIO45			       = 45			 ; Gpio number
GPIO46			       = 46			 ; Gpio number
GPIO47			       = 47			 ; Gpio number
GPIO48			       = 48			 ; Gpio number
GPIO49			       = 49			 ; Gpio number
GPIO50			       = 50			 ; Gpio number
GPIO51			       = 51			 ; Gpio number
GPIO52			       = 52			 ; Gpio number
GPIO53			       = 53			 ; Gpio number

SCREEN_X		       = 800			 ; Screen X
SCREEN_Y		       = 600			 ; Screen Y
FONTSPACE		       = 17			 ; Font next row down size
ScreenSize		       = SCREEN_X*SCREEN_Y	 ; 800*600 (HEX 0x75300 )
; -----------------------------------------------------  ;
; Function Address                                       ;
; -----------------------------------------------------  ;
SetScreenRes		       = 0x8010+1*4		 ; Set screen res and bpp
SetBuffer		       = 0x8010+2*4		 ; Set frame Buffer address to ours
WriteOffScrBuff2screen	       = 0x8010+3*4		 ; Writes the frame buffer to screen
PrintToOffScreenBuffer	       = 0x8010+4*4		 ; Print a zero ending string to buffer
PrintToOffScreenBuffer1        = 0x8010+5*4		 ; Print
LoadBmpImage		       = 0x8010+6*4		 ; Loads a 24bit bmp, stores output to buffer
Alpha_Pixel		       = 0x8010+7*4		 ; Set the Alpha pixel value (value from 0-255)
PutBmpImage		       = 0x8010+8*4		 ; Put a bmp to screen or buffer at X Y
DeLayBy 		       = 0x8010+9*4		 ; Delay by the number of times in r2 * 0x100000
WriteOffScrBuff2screenDelay    = 0x8010+10*4		 ; Writes the frame buffer to screen with delay between each row
Uart_setup		       = 0x8010+11*4		 ; set mini uart baudrate
PrintStringUart0	       = 0x8010+12*4		 ; print zero termanated string serial 0
PrintCharUart0		       = 0x8010+13*4		 ; Prints char to serial 0
Uart_Read0		       = 0x8010+14*4		 ; Uart_Read serial 0
Uart_FlushTX		       = 0x8010+15*4		 ; Uart Flush TX
Uart_FlushRX		       = 0x8010+16*4		 ; Uart Flush RX
Delay_Microseconds	       = 0x8010+17*4		 ; delay Microseconds 1000000 = 1 second
Pin_Mode		       = 0x8010+18*4		 ; set pin mode
digital_Write		       = 0x8010+19*4		 ; Write to Gpio pin
; -----------------------------------------------------  ;
; Use imm32 Rd,$12345678 in your code etc...             ;
; -----------------------------------------------------  ;
macro imm32 reg,immediate {				 ;
mov reg,immediate and $FF				 ;
orr reg,reg,immediate and $FF00 			 ;
orr reg,reg,immediate and $FF0000			 ;
orr reg,reg,immediate and $FF000000			 ;
}							 ;
; -----------------------------------------------------  ;
; Screen                                                 ;
; -----------------------------------------------------  ;
; Set res of screen X Y BPP                              ;
;                                                        ;
; -----------------------------------------------------  ;
macro screen _scrX, _scrY, _bpp 			 ;
{							 ;
	push   (r0)					 ;
	push   (r1)					 ;
	push   (r2)					 ;
	push   (r10)					 ;
	imm32  r0,_scrX 				 ;
	imm32  r1,_scrY 				 ;
	imm32  r0,_bpp					 ;
	imm32  r10,SetScreenRes 			 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	pop    (r10)					 ;
	pop    (r2)					 ;
	pop    (r1)					 ;
	pop    (r0)					 ;
}							 ;
; -----------------------------------------------------  ;
; load                                                   ;
; -----------------------------------------------------  ;
; Load a bmp Image ( _ImageName ) to                     ;
; buffer Address ( _ImageBuffer )                        ;
;                                                        ;
; -----------------------------------------------------  ;
macro load _ImageName, _ImageBuffer			 ;
{							 ;
	push   (r0)					 ;
	push   (r1)					 ;
	push   (r10)					 ;
	imm32  r0,_ImageName				 ;
	imm32  r1,_ImageBuffer				 ;
	imm32  r10,LoadBmpImage 			 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	pop    (r10)					 ;
	pop    (r1)					 ;
	pop    (r0)					 ;
}							 ;
; -----------------------------------------------------  ;
; put                                                    ;
; -----------------------------------------------------  ;
; Put bmp image (ImageName) at X Y                       ;
;                                                        ;
; NOTE: will put direct to screen or buffer              ;
;       depending on settings.                           ;
; -----------------------------------------------------  ;
macro put _Image_Name, _Image_X, _Image_Y		 ;
{							 ;
	push   (r0)					 ;
	push   (r1)					 ;
	push   (r2)					 ;
	push   (r10)					 ;
	imm32  r0,_Image_Name				 ;
	imm32  r1,_Image_X				 ;
	imm32  r2,_Image_Y				 ;
	imm32  r10,PutBmpImage				 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	pop    (r10)					 ;
	pop    (r2)					 ;
	pop    (r1)					 ;
	pop    (r0)					 ;
}							 ;
; -----------------------------------------------------  ;
; cls (color)                                            ;
; -----------------------------------------------------  ;
; Clear the screen to the color                          ;
;                                                        ;
; -----------------------------------------------------  ;
Macro cls   _color1					 ;
{							 ;
	local .FillOffScrBuffLoopMacro			 ;
	push   (r0)					 ;
	push   (r1)					 ;
	push   (r2)					 ;
							 ;
	imm32  r0,SCREEN_X				 ;
	imm32  r1,SCREEN_Y				 ;
	mul    r2,r0,r1 				 ;
	push   (r2)					 ;
	imm32  r0,_color1				 ;
							 ;
	mov    r2,r0,lsr 24				 ;
	and    r1,r0,16711680				 ;
	orr    r2,r2,r0,lsl 24				 ;
	orr    r2,r2,r1,lsr 8				 ;
	and    r0,r0,65280				 ;
	orr    r0,r2,r0,lsl 8				 ;
	mov    r0,r0,lsr 8				 ;
	orr    r0,0xff000000				 ;
	imm32  r1,ScreenBuffer				 ;
	pop    (r2)					 ;
align 4 						 ;
.FillOffScrBuffLoopMacro:				 ;
	str    r0,[r1],4				 ;
	subs   r2,r2, 1 				 ;
	bne    .FillOffScrBuffLoopMacro 		 ;
	pop    (r2)					 ;
	pop    (r1)					 ;
	pop    (r0)					 ;
}							 ;
align 4 						 ;
; -----------------------------------------------------  ;
; Set Print X Y                                          ;
; -----------------------------------------------------  ;
; Move the where to print, to a particular X Y           ;
; X = any number from 1 to screen width.                 ;
; Y = any number from 1 to screen hight                  ;
;                                                        ;
; locate 5,40                                            ;
; This places the print start 5 pixels                   ;
; to the right, 40 pixel down the screen.                ;
;                                                        ;
; -----------------------------------------------------  ;
macro locate _X, _Y					 ;
{							 ;
	push   (r0)					 ;
	push   (r1)					 ;
	mov    r1,_X					 ;
	imm32  r0,vesa_font_X				 ;
	str    r1,[r0]					 ;
	mov    r1,_Y					 ;
	imm32  r0,vesa_font_Y				 ;
	str    r1,[r0]					 ;
	pop    (r1)					 ;
	pop    (r0)					 ;
}							 ;
; -----------------------------------------------------  ;
; alpha                                                  ;
; -----------------------------------------------------  ;
; Set Alpha Value from (0-255)                           ;
;                                                        ;
; -----------------------------------------------------  ;
macro alpha _AlphaV					 ;
{							 ;
	push   (r0)					 ;
	push   (r10)					 ;
	imm32  r0,_AlphaV				 ;
	imm32  r10,Alpha_Pixel				 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	pop    (r10)					 ;
	pop    (r0)					 ;
}							 ;

; -----------------------------------------------------  ;
; pinMode                                                ;
; -----------------------------------------------------  ;
; _op1 = Gpio number between 0-53                        ;
; _op2 =                                                 ;
;      INPUT  = 0                                        ;
;      OUTPUT = 1                                        ;
;      ALT0   = 4                                        ;
;      ALT1   = 5                                        ;
;      ALT2   = 6                                        ;
;      ALT3   = 7                                        ;
;      ALT4   = 3                                        ;
;      ALT5   = 2                                        ;
;                                                        ;
; -----------------------------------------------------  ;
macro pinMode _op1, _op2				 ;
{							 ;
	push   (r0)					 ;
	push   (r1)					 ;
	push   (r10)					 ;
	imm32  r0,_op1					 ;
	imm32  r1,_op2					 ;
	imm32  r10,Pin_Mode				 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	pop    (r10)					 ;
	pop    (r1)					 ;
	pop    (r0)					 ;
}							 ;
; -----------------------------------------------------  ;
; pinMode                                                ;
; -----------------------------------------------------  ;
; _op1 = Gpio number between 0-53                        ;
; _op2 =                                                 ;
;        LOW  = 0 (eg: LED off)                          ;
;        HIGH = 1 (eg: LED on)                           ;
;                                                        ;
; -----------------------------------------------------  ;
macro digitalWrite _op1, _op2				 ;
{							 ;
	push   (r0)					 ;
	push   (r1)					 ;
	push   (r10)					 ;
	imm32  r0,_op1					 ;
	imm32  r1,_op2					 ;
	imm32  r10,digital_Write			 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	pop    (r10)					 ;
	pop    (r1)					 ;
	pop    (r0)					 ;
}							 ;
; -----------------------------------------------------  ;
; delay                                                  ;
; -----------------------------------------------------  ;
; delay by number of seconds                             ;
; 10 = 1 second                                          ;
;                                                        ;
; -----------------------------------------------------  ;
macro delay _delayTime					 ;
{							 ;
	push   (r2)					 ;
	push   (r10)					 ;
	imm32  r2,_delayTime				 ;
	imm32  r10,DeLayBy				 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	pop    (r10)					 ;
	pop    (r2)					 ;
}							 ;
; -----------------------------------------------------  ;
; delayMicroseconds                                      ;
; -----------------------------------------------------  ;
; delay by number of microseconds                        ;
; 1000000 = 1 second                                     ;
;                                                        ;
; -----------------------------------------------------  ;
macro delayMicroseconds _delayMicrosecondsTime		 ;
{							 ;
	push   (r0)					 ;
	push   (r10)					 ;
	imm32  r0,_delayMicrosecondsTime		 ;
	imm32  r10,Delay_Microseconds			 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	pop    (r10)					 ;
	pop    (r0)					 ;
}							 ;
; -----------------------------------------------------  ;
; serial.setup                                           ;
; -----------------------------------------------------  ;
; sets uart baud rate                                    ;
; defaults to 115200                                     ;
;                                                        ;
; -----------------------------------------------------  ;
macro serial.setup _baudrate				 ;
{							 ;
	push   (r0)					 ;
	push   (r2)					 ;
	push   (r10)					 ;
	imm32  r2,3					 ;
	imm32  r10,DeLayBy				 ; need a small delay
	ldr    r10,[r10]				 ; before setting new
	blx    r10					 ; baud rate
	imm32  r0,_baudrate				 ;
	imm32  r10,Uart_setup				 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	pop    (r10)					 ;
	pop    (r2)					 ;
	pop    (r0)					 ;
}							 ;
; -----------------------------------------------------  ;
; serial.uartTXflush                                     ;
; -----------------------------------------------------  ;
; flush uart TX buffer                                   ;
;                                                        ;
; -----------------------------------------------------  ;
macro serial.uartTXflush				 ;
{							 ;
	push   (r10)					 ;
	imm32  r10,Uart_FlushTX 			 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	pop    (r10)					 ;
}							 ;
; -----------------------------------------------------  ;
; serial.uartRXflush                                     ;
; -----------------------------------------------------  ;
; flush uart RX buffer                                   ;
;                                                        ;
; -----------------------------------------------------  ;
macro serial.uartRXflush				 ;
{							 ;
	push   (r10)					 ;
	imm32  r10,Uart_FlushRX 			 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	pop    (r10)					 ;
}							 ;
; -----------------------------------------------------  ;
; serial.print                                           ;
; -----------------------------------------------------  ;
; Print whats in the quotes to mini uart                 ;
;                                                        ;
; -----------------------------------------------------  ;
macro serial.print _uartString{ 			 ;
	local .Done					 ;
	local .a					 ;
	push   (r0)					 ;
	push   (r10)					 ;
	imm32  r0,.a					 ;
	imm32  r10,PrintStringUart0			 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	b      .Done					 ;
align 4 						 ;
	.a db _uartString,0				 ;
align 4 						 ;
	.Done:						 ;
	pop    (r10)					 ;
	pop    (r0)					 ;
}							 ;
; -----------------------------------------------------  ;
; serial.println                                         ;
; -----------------------------------------------------  ;
; Print whats in the quotes to mini uart
; with carriage return and a newline character           ;
;                                                        ;
; -----------------------------------------------------  ;
macro serial.println _uartString{			 ;
	local .Done					 ;
	local .a					 ;
	push   (r0)					 ;
	push   (r10)					 ;
	imm32  r0,.a					 ;
	imm32  r10,PrintStringUart0			 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	b      .Done					 ;
align 4 						 ;
	.a db _uartString,13,10,0			 ;
align 4 						 ;
	.Done:						 ;
	pop    (r10)					 ;
	pop    (r0)					 ;
}							 ;
; -----------------------------------------------------  ;
; color                                                  ;
; -----------------------------------------------------  ;
; Change color of font on next print                     ;
;                                                        ;
; -----------------------------------------------------  ;
macro color _opt1					 ;
{							 ;
	push   (r0)					 ;
	push   (r1)					 ;
	push   (r2)					 ;
	imm32  r0,_opt1 				 ;
							 ;
	mov    r2,r0,lsr 24				 ;
	and    r1,r0,16711680				 ;
	orr    r2,r2,r0,lsl 24				 ;
	orr    r2,r2,r1,lsr 8				 ;
	and    r0,r0,65280				 ;
	orr    r0,r2,r0,lsl 8				 ;
	mov    r0,r0,lsr 8				 ;
	orr    r0,0xff000000				 ;
	imm32  r1,Font_Color				 ;
	str    r0,[r1]					 ;
	pop    (r2)					 ;
	pop    (r1)					 ;
	pop    (r0)					 ;
}							 ;
align 4 						 ;
; -----------------------------------------------------  ;
; print                                                  ;
; -----------------------------------------------------  ;
; Print something out, whatever, in quotes               ;
; print "Hello World!"                                   ;
;                                                        ;
; -----------------------------------------------------  ;
macro print String{					 ;
	local .Done					 ;
	local .a					 ;
	push   (r0)					 ;
	push   (r1)					 ;
	push   (r2)					 ;
	push   (r3)					 ;
	push   (r4)					 ;
	push   (r5)					 ;
	push   (r6)					 ;
	push   (r10)					 ;
							 ;
	imm32  r1,vesa_font_X				 ;
	ldr    r1,[r1]					 ;
	imm32  r2,vesa_font_Y				 ;
	ldr    r2,[r2]					 ;
	imm32  r3,Font_Color				 ;
	ldr    r3,[r3]					 ;
	adr    r0,.a					 ;
	imm32  r10,PrintToOffScreenBuffer		 ;
	ldr    r10,[r10]				 ;
	blx    r10					 ;
	b      .Done					 ;
align 4 						 ;
	.a db String,0					 ;
align 4 						 ;
	.Done:						 ;
							 ;
	imm32  r0,vesa_font_Y				 ;
	ldr    r1,[r0]					 ;
	add    r1,r1,FONTSPACE				 ;
	str    r1,[r0]					 ;
	pop    (r10)					 ;
	pop    (r6)					 ;
	pop    (r5)					 ;
	pop    (r4)					 ;
	pop    (r3)					 ;
	pop    (r2)					 ;
	pop    (r1)					 ;
	pop    (r0)					 ;
}							 ;
; -----------------------------------------------------  ;
; sync                                                   ;
; -----------------------------------------------------  ;
; Write back buffer to Screen                            ;
;                                                        ;
; -----------------------------------------------------  ;
macro sync						 ;
{							 ;
	push   (r10)					 ;
	imm32	r10,WriteOffScrBuff2screen		 ;
	ldr	r10,[r10]				 ;
	blx	r10					 ;
	pop    (r10)					 ;
}							 ;
; -----------------------------------------------------  ;
; syncs                                                  ;
; -----------------------------------------------------  ;
; Write back buffer to screen with delay in between      ;
; each rows.                                             ;
; -----------------------------------------------------  ;
macro syncs						 ;
{							 ;
	push   (r10)					 ;
	imm32	r10,WriteOffScrBuff2screenDelay 	 ;
	ldr	r10,[r10]				 ;
	blx	r10					 ;
	pop    (r10)					 ;
}							 ;
; -----------------------------------------------------  ;
; substart                                               ;
; -----------------------------------------------------  ;
; Function START so saves some regs                      ;
;                                                        ;
; NOTE: does not save r0-r3                              ;
; -----------------------------------------------------  ;
Macro substart						 ;
{							 ;
	push   (lr)					 ;
	push   (r4)					 ;
	push   (r5)					 ;
	push   (r6)					 ;
	push   (r7)					 ;
	push   (r8)					 ;
	push   (r9)					 ;
	push   (r10)					 ;
	push   (r11)					 ;
}							 ;
; -----------------------------------------------------  ;
; Return (return from function so restore regs)          ;
; -----------------------------------------------------  ;
; Return from function so restore regs                   ;
;                                                        ;
; -----------------------------------------------------  ;
Macro return						 ;
{							 ;
	pop   (r11)					 ;
	pop   (r10)					 ;
	pop   (r9)					 ;
	pop   (r8)					 ;
	pop   (r7)					 ;
	pop   (r6)					 ;
	pop   (r5)					 ;
	pop   (r4)					 ;
	pop   (pc)					 ;
}							 ;
; -----------------------------------------------------  ;
; goto                                                   ;
; -----------------------------------------------------  ;
; jmp to label                                           ;
;                                                        ;
; -----------------------------------------------------  ;
Macro goto _op1 					 ;
{							 ;
	b     _op1					 ;
}							 ;
; -----------------------------------------------------  ;
; gosub                                                  ;
; -----------------------------------------------------  ;
; Call a function                                        ;
;                                                        ;
; -----------------------------------------------------  ;
Macro gosub _subname					 ;
{							 ;
	imm32  r10,_subname				 ;
	blx    r10					 ;
}							 ;
; -----------------------------------------------------  ;
; end                                                    ;
; -----------------------------------------------------  ;
; Just loop for now                                      ;
;                                                        ;
; -----------------------------------------------------  ;
macro end						 ;
{							 ;
       local .JustLoop					 ;
.JustLoop:						 ;
       b     .JustLoop					 ;
}							 ;
; -----------------------------------------------------  ;
; Main Program Header                                    ;
; -----------------------------------------------------  ;
format binary as 'bin'					 ; Set the assembled file to bin
org	0x1400000					 ; The load address of this app 20MB
use32							 ; Use 32bit
Lable:	db	'DEX '					 ; Test this to make sure its valid.
	dw	ProgramSize-Lable			 ; This is the size of program
	b	Start					 ;
; -----------------------------------------------------  ;
; Some var used in Macros                                ;
; -----------------------------------------------------  ;
vesa_font_X	dw   0					 ; X var for print
vesa_font_Y	dw   0					 ; Y var for print
Font_Color	dw   0					 ; Font color
align 4 						 ;
; -----------------------------------------------------  ;
; Start of program                                       ;
; -----------------------------------------------------  ;
Start:							 ;
	imm32	r0,ScreenBuffer 			 ; Get the off screen buffer address
	imm32	r10,SetBuffer				 ; Get the address of function
	ldr	r10,[r10]				 ;
	blx	r10					 ; call the function
	cls	0x00000000				 ; clear screen buffer to black
	color	0x00ffffff				 ; Set default font color